module misc.Error;

import tango.core.Exception,
       tango.text.Util : layout;

import llvm.type;

import misc.Location,
       sema.Symbol;

class Error : Exception
{

    this(char[] message)
    {
        super(message);
        args ~= message;
    }

    char[] toString()
    {
        char[256] tmp = void;
        char[] msg = layout(tmp, args);
        if (locs.length > 0)
            msg = locs[0].toString ~ ": " ~ msg;
        else
            msg = msg.dup;
        return msg;
    }

    Error arg(char[] s)
    {
        if (args.length == 11)
            throw new Exception("Sorry, errors only support up to 10 args");
        args ~= s;
        return this;
    }

    Error arg(char c)
    {
        return arg([c]);
    }

    Error arg(DType type)
    {
        return arg(type.name());
    }

    Error arg(Symbol sym)
    {
        return arg(sym.type.name ~ " " ~ sym.id.get);
    }

    Error loc(Location loc)
    {
        locs ~= loc;
        return this;
    }

private:
    char[][] args;
    Location[] locs;
}
